/* 
 * $RCSfile: gj_autoaway.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/04/24 15:58:09 $
 * 
 * $Revision: 1.3 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <gdk/gdk.h>

#ifdef HAVE_XSS

#include <X11/X.h>
#include <X11/Xlib.h>

#include <X11/extensions/scrnsaver.h>
#include <gdk/gdkx.h>

static Display *display = NULL;

#endif /* HAVE_XSS */

#include "gj_autoaway.h"
#include "gj_gtk_roster.h"


void gj_autoaway_check();
gboolean gj_autoaway_callback(gpointer data);

/*
 * Used by most functions 
 */
struct 
{
  GTimer *timer;
  guint timeout_id;

} optAutoAway;

/*
 * code
 */
gboolean gj_autoaway_init()
{
#ifdef HAVE_XSS

  gint unused;
  Bool useXss = False;

  /*
   *  Find out whether there actually is a server on the other side...
   */
  if(!(display = XOpenDisplay(0))) /* = intended */
  {
    g_warning("gj_autoaway_init: couldn't connect to %s", XDisplayName(0));
    return FALSE;
  }

  if(!(useXss = XScreenSaverQueryExtension(display, &unused, &unused)))
    {
      g_warning("gj_autoaway_init: could not initialise XScreenSaver");
      return FALSE;
    }

  g_message("gj_autoaway_init: using XSS for autoaway time");

#else /* HAVE_XSS */

  g_message("gj_autoaway_init: no way to know autoaway time");

#endif /* HAVE_XSS */

  /* set recursive function */
  optAutoAway.timeout_id = g_timeout_add(1000,
					 gj_autoaway_callback,
					 NULL);

  return TRUE;
}

gboolean gj_autoaway_term()
{
  return TRUE;
}

#ifndef WIN32

void gj_autoaway_check()
{
  gint time = 0; /* in ms */

#ifdef HAVE_XSS

  /* find out current idle time */
  time = gj_autoaway_query_ss_idle_time(display);
  gj_gtk_roster_autoaway_update(time);

#endif /* HAVE_XSS */
}

#ifdef HAVE_XSS 

gint gj_autoaway_query_ss_idle_time(Display *d)
{
  Time idleTime = 0; /* millisecs since last input event */

  static XScreenSaverInfo *mitInfo = 0; 

  if(!mitInfo) 
    mitInfo = XScreenSaverAllocInfo();
  
  XScreenSaverQueryInfo(d, DefaultRootWindow (d), mitInfo);
  idleTime = mitInfo->idle;

  return idleTime;
}

#endif /* HAVE_XSS */

#else /* WIN32 */

void gj_autoaway_check()
{
  /* cant do anything yet */
}

#endif /* WIN32 */

gboolean gj_autoaway_callback(gpointer data)
{
  /* return FALSE to stop 
     calling this function */

  /* do check */
  gj_autoaway_check();

  return TRUE;
}

#ifdef __cplusplus
}
#endif
