/* 
 * $RCSfile: gj_event.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/20 20:28:15 $
 * 
 * $Revision: 1.4 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_event_h
#define __gj_event_h

#include <glib.h>

#include "gj_presence.h"
#include "gj_message.h"
#include "gj_roster.h"


/* 
 * event types
 */
typedef enum eventType {
  eventTypePresence = 1,
  eventTypeMessage,
  eventTypeFile,

  eventTypeEnd
} eventType;


typedef struct t_event *event;

typedef void (*eventProc)(gint eventID);

gboolean gj_event_init();
gboolean gj_event_term();

gboolean gj_event_set_cb(eventProc proc);
eventProc gj_event_get_cb();

/* 
 * item functions
 */

/* create/delete */
event gj_event_new(gchar *jid, eventType type, void *data);
gboolean gj_event_new_by_post_from_jid(gchar *jid, eventType type, void *data);
gboolean gj_event_new_by_post_from_ri_id(gint id, eventType type, void *data);
gboolean gj_event_free(event ev);
gboolean gj_event_free_by_id(gint eventID);

/* find */
event gj_event_find_by_id(gint eventID);
event gj_event_find_next_by_type(rosterItem ri, eventType type);
event gj_event_find_next_by_type_and_message_type(rosterItem ri, eventType type, messageType messageType);

/* utils */
event gj_event_nth(gint index);
event gj_event_nth_by_roster_item(rosterItem ri, gint index);
gint gj_event_next(rosterItem ri);

gint gj_event_count(rosterItem ri);
gint gj_event_count_by_type(rosterItem ri, eventType type);

/* 
 * member functions 
 */

/* gets */
gint gj_event_get_id(event ev);
gchar *gj_event_get_jid(event ev);
eventType gj_event_get_type(event ev);
void *gj_event_get_data(event ev);
time_t gj_event_get_time(event ev);
gint gj_event_get_ri_id(event ev);
rosterItem gj_event_get_roster_item(event ev);

/* sets */
gboolean gj_event_set_ri_id(event ev, gint id);

/* debugging */
void gj_event_print_all(rosterItem ri);
void gj_event_print(event ev);

#endif

#ifdef __cplusplus
}
#endif
