/* 
 * $RCSfile: gj_gtk_browse_services.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/31 16:43:54 $
 * 
 * $Revision: 1.25 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include <unistd.h>

#include "common.h"

#include "gj_main.h"
#include "gj_roster.h"
#include "gj_agents.h"
#include "gj_iq_requests.h"
#include "gj_parser.h"
#include "gj_me.h"

#include "gj_gtk_browse_services.h"
#include "gj_gtk_register_service.h"
#include "gj_gtk_support.h"
#include "gj_gtk_msg.h"

/* columns */
enum
  { 
    COL_BROWSE_SERVICE_JID,
    COL_BROWSE_SERVICE_NAME,
    COL_BROWSE_SERVICE_DESCRIPTION,
    COL_BROWSE_SERVICE_TRANSPORT,
    COL_BROWSE_SERVICE_GROUPCHAT,
    COL_BROWSE_SERVICE_SERVICE,
    COL_BROWSE_SERVICE_REGISTER,
    COL_BROWSE_SERVICE_SEARCH,
    COL_BROWSE_SERVICE_VISIBLE,
    COL_BROWSE_SERVICE_ARE_WE_REGISTERED,
    COL_BROWSE_SERVICE_COUNT
  };


struct 
{
  GtkWidget *window;
  
  GtkWidget *table;
  
  GtkWidget *combo_server;
  GtkWidget *combo_entry_server;
  GtkWidget *button_refresh;
    
  GtkWidget *treeview;
  GtkWidget *button_register;
  GtkWidget *button_unregister;

  GtkWidget *label_waiting;
  GtkWidget *progressbar_waiting;

  GtkWidget *button_close;
  GtkWidget *button_help;

} ctlBS;

struct
{
  gchar *jid; /* jid that the register/unregister was done to */

  gint timer_id;
  gint timer_time_elapsed;
  gint timer_time_total;

} optBS;


gboolean gj_gtk_bs_setup();

gboolean gj_gtk_bs_is_window_valid();

gboolean gj_gtk_bs_timer_start();
gboolean gj_gtk_bs_timer_stop();
gboolean gj_gtk_bs_timer_cb(gpointer data);
/* void gj_gtk_bs_timer_cb(gboolean timeout_expired, void *userdata); */

void gj_gtk_bs_enable_controls(gboolean enabled);
void gj_gtk_bs_show_progress(gboolean show);

/*
 * member functions
 */ 

/* gets */
gchar *gj_gtk_bs_get_jid();
gint gj_gtk_bs_get_timer_id();
gint gj_gtk_bs_get_timer_time_elapsed();
gint gj_gtk_bs_get_timer_time_total();

/* sets */
gboolean gj_gtk_bs_set_jid(gchar *jid);
gboolean gj_gtk_bs_set_timer_id(gint id);
gboolean gj_gtk_bs_set_timer_time_elapsed(gint seconds);
gboolean gj_gtk_bs_set_timer_time_total(gint seconds);


/*
 * model functions 
 */
gboolean gj_gtk_bs_model_setup();
gboolean gj_gtk_bs_model_populate_columns(GtkTreeView *view);
gboolean gj_gtk_bs_model_get_selection(gchar **jid);

/* internal callbacks */
void gj_gtk_bs_agent_list_response(GList *list, gint error_code, gchar *error_message);
void gj_gtk_bs_unregister_response(guint eventID);

/* gui callbacks */
void on_treeview_bs_selection_changed(GtkTreeSelection *treeselection, gpointer user_data);

void on_button_bs_find_clicked(GtkButton *button, gpointer user_data);
void on_button_bs_refresh_clicked(GtkButton *button, gpointer user_data);
void on_button_bs_register_clicked(GtkButton *button, gpointer user_data);
void on_button_bs_unregister_clicked(GtkButton *button, gpointer user_data);

void on_browse_services_response(GtkDialog *dialog, gint response, gpointer user_data);


/* 
 * member functions 
 */

/* gets */
gchar *gj_gtk_bs_get_jid()
{
  return optBS.jid;
}

gint gj_gtk_bs_get_timer_id()
{
  return optBS.timer_id;
}

gint gj_gtk_bs_get_timer_time_elapsed()
{
  return optBS.timer_time_elapsed;
}

gint gj_gtk_bs_get_timer_time_total()
{
  return optBS.timer_time_total;
}

/* sets */
gboolean gj_gtk_bs_set_jid(gchar *jid)
{
  if(jid == NULL)
    {
      g_warning("%s: jid was NULL", __FUNCTION__);
      return FALSE;
    }

  if(optBS.jid != NULL)
    {
      g_free(optBS.jid);
      optBS.jid = NULL;
    }

  optBS.jid = g_strdup(jid);

  return TRUE;
}

gboolean gj_gtk_bs_set_timer_id(gint id)
{
  if(id < 0)
    {
      g_warning("%s: id:%d was < 0", __FUNCTION__, id);
      return FALSE;
    }

  optBS.timer_id = id;
  return TRUE;
}

gboolean gj_gtk_bs_set_timer_time_elapsed(gint seconds)
{
  if(seconds < 0)
    {
      g_warning("%s: seconds:%d was < 0", __FUNCTION__, seconds);
      return FALSE;
    }

  optBS.timer_time_elapsed = seconds;
  return TRUE;
}

gboolean gj_gtk_bs_set_timer_time_total(gint seconds)
{
  if(seconds < 0)
    {
      g_warning("%s: seconds:%d was < 0", __FUNCTION__, seconds);
      return FALSE;
    }

  optBS.timer_time_total = seconds;
  return TRUE;
}

/*
 * window functions
 */
gboolean gj_gtk_bs_load()
{
  GladeXML *xml = NULL;

  if(ctlBS.window != NULL)
    {
      gtk_window_present(GTK_WINDOW(ctlBS.window));
      return TRUE;
    }

  optBS.jid = NULL;
  gj_gtk_bs_set_timer_id(0);
  gj_gtk_bs_set_timer_time_elapsed(0);
  gj_gtk_bs_set_timer_time_total(15);

  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "browse_services",
			  NULL)) == NULL)
    {
      g_warning("%s: couldn't open glade file at root 'browse_services'", __FUNCTION__);
      return FALSE;
    }
  
  ctlBS.window = glade_xml_get_widget(xml,"browse_services");

  ctlBS.table = glade_xml_get_widget(xml,"table_bs");

  ctlBS.combo_server = glade_xml_get_widget(xml,"combo_bs_server");
  ctlBS.combo_entry_server = glade_xml_get_widget(xml,"combo-entry_bs_server");
  ctlBS.button_refresh = glade_xml_get_widget(xml, "button_bs_refresh");

  ctlBS.treeview = glade_xml_get_widget(xml,"treeview_bs");
  ctlBS.button_register = glade_xml_get_widget(xml, "button_bs_register");
  ctlBS.button_unregister = glade_xml_get_widget(xml, "button_bs_unregister");

  ctlBS.label_waiting = glade_xml_get_widget(xml, "label_bs_waiting");
  ctlBS.progressbar_waiting = glade_xml_get_widget(xml, "progressbar_bs_waiting");

  ctlBS.button_close = glade_xml_get_widget(xml,"button_bs_close");
  ctlBS.button_help = glade_xml_get_widget(xml,"button_bs_help");

  gdk_window_set_decorations (GDK_WINDOW(ctlBS.window->window), 
			      GDK_DECOR_BORDER | GDK_DECOR_TITLE | GDK_DECOR_MENU | GDK_DECOR_RESIZEH);
  
#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  g_signal_connect ((gpointer) ctlBS.window, "response",
		    G_CALLBACK (on_browse_services_response),
		    NULL);
  g_signal_connect ((gpointer) ctlBS.button_refresh, "clicked",
		    G_CALLBACK (on_button_bs_refresh_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlBS.button_register, "clicked",
		    G_CALLBACK (on_button_bs_register_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlBS.button_unregister, "clicked",
		    G_CALLBACK (on_button_bs_unregister_clicked),
		    NULL);
#endif

  /* setup controls */
  gj_gtk_bs_setup();

  /* clean up */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_bs_unload()
{
  if(ctlBS.window == NULL)
    return TRUE;

  gtk_widget_destroy(ctlBS.window);

  ctlBS.window = NULL;
  
  ctlBS.table = NULL;

  ctlBS.combo_server = NULL;
  ctlBS.combo_entry_server = NULL;
  ctlBS.button_refresh = NULL;

  ctlBS.treeview = NULL;
  ctlBS.button_register = NULL;
  ctlBS.button_unregister = NULL;

  ctlBS.label_waiting = NULL;
  ctlBS.progressbar_waiting = NULL;

  ctlBS.button_close = NULL;
  ctlBS.button_help = NULL;

  if(optBS.jid != NULL)
    {
      g_free(optBS.jid);
      optBS.jid = NULL;
    }

  optBS.timer_id = 0;
  optBS.timer_time_elapsed = 0;
  optBS.timer_time_total = 15;

  return TRUE;
}

gboolean gj_gtk_bs_setup()
{
  GList *servers = NULL;
  const gchar **server_listing = NULL;
  const gchar *str = NULL;
  gint i = 0;

  server_listing = gnome_jabber_get_server_list();
  
  /* set a limit of a 1000 */
  while((str = server_listing[i++]) != NULL && i < 1000)
      servers = g_list_append(servers, (gchar*)str);

  gtk_combo_set_popdown_strings(GTK_COMBO(ctlBS.combo_server), servers);

  /* cleanup */
  if(servers != NULL) g_list_free(servers);

  if(gj_me_get_connected_host() != NULL)
    gtk_entry_set_text(GTK_ENTRY(ctlBS.combo_entry_server), gj_me_get_connected_host());

  /* set up list */
  gj_gtk_bs_model_setup();

  return TRUE;
}

gboolean gj_gtk_bs_is_window_valid()
{
  return ctlBS.window != NULL ? TRUE : FALSE;
}

gboolean gj_gtk_bs_timer_start()
{
  gint id = 0;

  /* show controls */
  gj_gtk_bs_show_progress(TRUE);
  gj_gtk_bs_enable_controls(FALSE);

  gj_gtk_bs_set_timer_id(0);
  gj_gtk_bs_set_timer_time_elapsed(0);
  gj_gtk_bs_set_timer_time_total(15);

  /* start timer */
  id = gtk_timeout_add(1000, gj_gtk_bs_timer_cb, NULL);
  gj_gtk_bs_set_timer_id(id);

  return TRUE;
}

gboolean gj_gtk_bs_timer_stop()
{
  /* hide controls */
  gj_gtk_bs_show_progress(FALSE);
  gj_gtk_bs_enable_controls(TRUE);

  /* stop timer */
  gtk_timeout_remove(gj_gtk_bs_get_timer_id());

  return TRUE;
}

gboolean gj_gtk_bs_timer_cb(gpointer data)
{
  gdouble percentage = 0;

  g_message("%s: time elapsed:%2.2d or %2.2d (seconds)", __FUNCTION__, 
	    gj_gtk_bs_get_timer_time_elapsed() + 1, gj_gtk_bs_get_timer_time_total());
  
  if((gj_gtk_bs_get_timer_time_elapsed() + 1) >= gj_gtk_bs_get_timer_time_total())
    {
      g_message("%s: time is up, elapsed time:%d is >= total time:%d", __FUNCTION__,
		gj_gtk_bs_get_timer_time_elapsed() + 1, gj_gtk_bs_get_timer_time_total());

      gj_gtk_bs_show_progress(FALSE);
      gj_gtk_bs_enable_controls(TRUE);

      gj_gtk_msg_new(TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_ERROR,
		     (MsgCb)NULL,
		     NULL,
		     _("Service Timed out"),
		     _("Try another server..."),
		     NULL); 

      return FALSE;
    }

  /* set new time waited */
  gj_gtk_bs_set_timer_time_elapsed(gj_gtk_bs_get_timer_time_elapsed() + 1);

  percentage = (gdouble)gj_gtk_bs_get_timer_time_elapsed()/gj_gtk_bs_get_timer_time_total();

  /* set progressbar */
  gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(ctlBS.progressbar_waiting), percentage);

  return TRUE;
}

void gj_gtk_bs_enable_controls(gboolean enabled)
{
  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.treeview), enabled);

  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.combo_server), enabled);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.combo_entry_server), enabled);

  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.button_refresh), enabled);

  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.button_register), enabled);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.button_unregister), enabled);
  
  return;
}

void gj_gtk_bs_show_progress(gboolean show)
{
  if(show == TRUE)
    {
      gtk_widget_show(GTK_WIDGET(ctlBS.label_waiting));
      gtk_widget_show(GTK_WIDGET(ctlBS.progressbar_waiting));
    }
  else
    {
      gtk_widget_hide(GTK_WIDGET(ctlBS.label_waiting));
      gtk_widget_hide(GTK_WIDGET(ctlBS.progressbar_waiting));
    }
}

/*
 * model functions 
 */
gboolean gj_gtk_bs_model_setup()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreeSelection *selection = NULL;

  if((view = GTK_TREE_VIEW(ctlBS.treeview)) == NULL)
    {
      g_warning("%s: view was NULL", __FUNCTION__);
      return FALSE;
    }

  if((selection = GTK_TREE_SELECTION(gtk_tree_view_get_selection(view))) == NULL)
    {
      g_warning("%s: selection was NULL", __FUNCTION__);
      return FALSE;
    }

  /* create store */
  store = gtk_list_store_new(COL_BROWSE_SERVICE_COUNT,
			     G_TYPE_STRING,    /* jid */
			     G_TYPE_STRING,    /* name */
			     G_TYPE_STRING,    /* description */	
			     G_TYPE_STRING,    /* transport */
			     G_TYPE_STRING,    /* groupchat */
			     G_TYPE_STRING,    /* service */
			     G_TYPE_STRING,    /* register */
			     G_TYPE_STRING,    /* search */
			     G_TYPE_BOOLEAN,   /* visible */
			     G_TYPE_BOOLEAN);  /* are we registered ? */

  /* model */
  model  = GTK_TREE_MODEL(store);
  gtk_tree_view_set_model(view, model);

  /* selection */
  gtk_tree_selection_set_mode(selection, GTK_SELECTION_SINGLE);
  g_signal_connect(G_OBJECT(selection), "changed", G_CALLBACK(on_treeview_bs_selection_changed), NULL);

  /* columns */
  gj_gtk_bs_model_populate_columns(view);
  
  /* properties */
  gtk_tree_view_set_enable_search(view, TRUE);
  gtk_tree_view_set_search_column(view, COL_BROWSE_SERVICE_NAME); 
  gtk_tree_view_set_rules_hint(view, FALSE);
  gtk_tree_view_set_headers_visible(view, TRUE);
  gtk_tree_view_set_headers_clickable(view, TRUE);

  /* clean up */
  g_object_unref(G_OBJECT(store));

  return TRUE;
}

gboolean gj_gtk_bs_model_populate_columns(GtkTreeView *view)
{
  GtkTreeViewColumn *column = NULL; 
  GtkCellRenderer *renderer = NULL;
  guint col_offset = 0;

  if(GTK_TREE_VIEW(view) == NULL)
    {
      g_warning("%s: view was NULL", __FUNCTION__);
      return FALSE;
    }  

  /* COL_BROWSE_SERVICE_ARE_WE_REGISTERED */
  renderer = gtk_cell_renderer_toggle_new ();

  column = gtk_tree_view_column_new_with_attributes ("Reg'd",
						     renderer,
						     "active", COL_BROWSE_SERVICE_ARE_WE_REGISTERED,
						     NULL);

  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_ARE_WE_REGISTERED);
  gtk_tree_view_append_column(view, column);

  column = gtk_tree_view_get_column(view, col_offset);
/*   gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_ARE_WE_REGISTERED); */
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), FALSE);

  /* COL_BROWSE_SERVICE_NAME */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Name"),
							   renderer, 
							   "text", COL_BROWSE_SERVICE_NAME,
							   NULL);
  
  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_NAME);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_NAME);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);

#if 0
  /* COL_BROWSE_SERVICE_SERVICE */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Service"),
							   renderer, 
							   "text", COL_BROWSE_SERVICE_SERVICE,
							   NULL);
  
  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_SERVICE);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_SERVICE);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
#endif

#if 1
  /* COL_BROWSE_SERVICE_TRANSPORT */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Transport"),
							   renderer, 
							   "text", COL_BROWSE_SERVICE_TRANSPORT,
							   NULL);
  
  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_TRANSPORT);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_TRANSPORT);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
#endif

  /* COL_BROWSE_SERVICE_REGISTER */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Register"),
							   renderer, 
							   "text", COL_BROWSE_SERVICE_REGISTER,
							   NULL);
  
  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_REGISTER);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_REGISTER);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);

  /* COL_BROWSE_SERVICE_GROUPCHAT */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Groupchat"),
							   renderer, 
							   "text", COL_BROWSE_SERVICE_GROUPCHAT,
							   NULL);
  
  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_GROUPCHAT);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_GROUPCHAT);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);

  /* COL_BROWSE_SERVICE_SEARCH */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Search"),
							   renderer, 
							   "text", COL_BROWSE_SERVICE_SEARCH,
							   NULL);
  
  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_SEARCH);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_SEARCH);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);

#if 0
  /* COL_BROWSE_SERVICE_DESCRIPTION */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Description"),
							   renderer, 
							   "text", COL_BROWSE_SERVICE_DESCRIPTION,
							   NULL);
  
  g_object_set_data(G_OBJECT(renderer), "column", (gint*)COL_BROWSE_SERVICE_DESCRIPTION);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_BROWSE_SERVICE_DESCRIPTION);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
#endif

  return TRUE;
}

gboolean gj_gtk_bs_model_get_selection(gchar **jid)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeSelection *selection = NULL;
  GtkTreeIter iter;
  
  if(jid == NULL)
    {
      g_warning("%s: jid pointer passed was NULL", __FUNCTION__);
      return FALSE;
    }

  if((view = GTK_TREE_VIEW(ctlBS.treeview)) == NULL)
    {
      g_warning("%s: view was NULL", __FUNCTION__);
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("%s: model was NULL", __FUNCTION__);
      return FALSE;
    }

  if((selection = GTK_TREE_SELECTION(gtk_tree_view_get_selection(view))) == NULL)
    {
      g_warning("%s: selection was NULL", __FUNCTION__);
      return FALSE;
    }

  if(gtk_tree_selection_get_selected(selection, &model, &iter) == FALSE)
    return FALSE;
  
  gtk_tree_model_get(model, &iter, 
		     COL_BROWSE_SERVICE_JID, jid,
		     -1);     

  return TRUE;
}

/* sets */
gboolean gj_gtk_bs_set_agent_registered(gchar *jid, gboolean registered)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreeIter iter;

  gboolean valid = FALSE;
  
  if(jid == NULL)
    {
      g_warning("%s: jid was NULL", __FUNCTION__);
      return FALSE;
    }

  if((view = GTK_TREE_VIEW(ctlBS.treeview)) == NULL)
    {
      g_warning("%s: view was NULL", __FUNCTION__);
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("%s: model was NULL", __FUNCTION__);
      return FALSE;
    }

  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("%s: store was NULL", __FUNCTION__);
      return FALSE;
    }

  valid = gtk_tree_model_get_iter_first(model, &iter);
  
  for(;valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      gchar *text = NULL;

      gtk_tree_model_get(model, &iter, 
			 COL_BROWSE_SERVICE_JID, &text,
			 -1);     

      if(text == NULL)
	continue;

      if(strcmp(text, jid) == 0)
	{
	  gtk_list_store_set(store, &iter, 
			     COL_BROWSE_SERVICE_ARE_WE_REGISTERED, registered,
			     -1);    
	}
      
      g_free(text);
    }

  return TRUE;
} 

/* internal callbacks */
void gj_gtk_bs_agent_list_response(GList *agents, gint error_code, gchar *error_reason)
{
  GtkTreeView *view = NULL;
  GtkListStore *store = NULL;
  GtkTreeIter iter;

  gint i = 0;

  if(gj_gtk_bs_is_window_valid() == FALSE)
    {
      g_message("%s: window is no longer pertinant, not honoring response.", __FUNCTION__);
      return;
    }

  if(agents == NULL && error_code == 0 && error_reason == NULL)
    {
      g_warning("%s: agent list was NULL, error code was 0 and error message was NULL", __FUNCTION__);
      return;
    }

  if((view = GTK_TREE_VIEW(ctlBS.treeview)) == NULL)
    {
      g_warning("%s: view was NULL", __FUNCTION__);
      return;
    }

  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("%s: store was NULL", __FUNCTION__);
      return;
    }

  /* clear list if already pressed */
  gtk_list_store_clear(store);

  for(i=0;i<g_list_length(agents);i++)
    {
      agent ag = NULL;
      gboolean registered = FALSE;

      if((ag = (agent)g_list_nth_data(agents, i)) == NULL)
	{
	  g_warning("%s: list data at index:%d was NULL", __FUNCTION__, i);
	  continue;
	}
      
      registered = gj_roster_is_agent_registered(gj_agent_get_jid(ag));

      /* add */ 
      gtk_list_store_append(store, &iter);
      gtk_list_store_set(store, &iter,    
			 COL_BROWSE_SERVICE_JID, gj_agent_get_jid(ag),
			 COL_BROWSE_SERVICE_NAME, gj_agent_get_name(ag)?gj_agent_get_name(ag):"-",
			 COL_BROWSE_SERVICE_DESCRIPTION, gj_agent_get_description(ag)?gj_agent_get_description(ag):"-",
			 COL_BROWSE_SERVICE_TRANSPORT, gj_agent_get_transport(ag)?_("yes"):_("no"),
			 COL_BROWSE_SERVICE_GROUPCHAT, gj_agent_get_groupchat(ag)?_("yes"):_("no"),
			 COL_BROWSE_SERVICE_SERVICE, gj_agent_get_service(ag)?gj_agent_get_service(ag):"-",
			 COL_BROWSE_SERVICE_REGISTER, gj_agent_get_registers(ag)?_("yes"):_("no"),
			 COL_BROWSE_SERVICE_SEARCH, gj_agent_get_search(ag)?_("yes"):_("no"),
			 COL_BROWSE_SERVICE_VISIBLE, TRUE,
			 COL_BROWSE_SERVICE_ARE_WE_REGISTERED, registered,
			 -1);

      /* info */
      g_message("%s: agent %d, jid:'%s', name:'%s', desc:'%s', trans:'%s', groupchat:'%s', service:'%s', register:'%s', search:'%s', registered: %s",
		__FUNCTION__,
		i,
		gj_agent_get_jid(ag),
		gj_agent_get_name(ag),
		gj_agent_get_description(ag),
		gj_agent_get_transport(ag),
		gj_agent_get_groupchat(ag),
		gj_agent_get_service(ag),
		gj_agent_get_registers(ag),
		gj_agent_get_search(ag),
		registered?_("yes"):_("no"));
    }

  gj_gtk_bs_timer_stop();

  /* set buttons disabled */
  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.button_register), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.button_unregister), FALSE);

  /* handle error */
  if(error_code != 0 || error_reason != NULL)
    {
      gj_gtk_msg_new(TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_ERROR,
		     (MsgCb)NULL,
		     NULL,
		     _("Failed to Browse Services."),
		     "%s %d - %s",
		     _("Error"),
		     error_code?error_code:0,
		     error_reason?error_reason:"",
		     NULL); 
    }
}

void gj_gtk_bs_unregister_response(guint eventID)
{
  infoquery iq_related = NULL;

  xmlNodePtr node = NULL;
  xmlChar *type = NULL;

  if((iq_related = gj_iq_find_by_related_id(eventID)) == NULL)
    {
      g_warning("%s: could not find IQ from eventID:%d", __FUNCTION__, eventID);
      return;
    }

  node = gj_iq_get_xml(iq_related);
  type = gj_parser_find_by_attr_and_ret(node, (guchar*)"type");

  if(type != NULL && xmlStrcmp(type, (guchar*)"error") == 0)
    {
      gchar *detail = NULL;

      xmlChar *errorCode = NULL;
      xmlChar *errorReason = NULL;

      if((node = gj_parser_find_by_node(node, (guchar*)"error")) == NULL)
	{
	  g_warning("%s: failed to find node 'error'", __FUNCTION__);
	  gj_iq_free_by_event_id(eventID);
	  return;
	}

      errorCode = gj_parser_find_by_attr_and_ret(node, (guchar*)"code");
      errorReason = gj_parser_find_by_node_and_ret(node, (guchar*)"error");

      gj_gtk_msg_new(TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_ERROR,
		     (MsgCb)NULL,
		     NULL,
		     _("Failed to Unregister Service."),
		     "%s %s - %s",
		     _("Error"),
		     errorCode?(gchar*)errorCode:"",
		     errorReason?(gchar*)errorReason:"",
		     NULL); 

      /* clean up */
      g_free(detail);
      gj_iq_free_all_related_by_related_id(eventID);

      return;
    }

  /* update table of information */
  gj_gtk_bs_set_agent_registered(gj_gtk_bs_get_jid(), FALSE);

      gj_gtk_msg_new(TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_INFORMATION,
		     (MsgCb)NULL,
		     NULL,
		     _("Unregister Service Success."),
		     "",
		     NULL); 
}

/* 
 * gui callbacks
 */
void on_treeview_bs_selection_changed(GtkTreeSelection *treeselection, gpointer user_data)
{
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;

  gboolean registered = FALSE;

  if(gtk_tree_selection_get_selected(treeselection, &model, &iter) == FALSE)
    {
      g_message("on_treeview_bs_selection_changed: there is nothing selected");
      return;
    }

  if(GTK_TREE_MODEL(model) == NULL)
    {
      g_warning("%s: model was NULL", __FUNCTION__);
      return;
    }

  gtk_tree_model_get(model, &iter,
		     COL_BROWSE_SERVICE_ARE_WE_REGISTERED, &registered,
		     -1);

  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.button_register), !registered);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlBS.button_unregister), registered);
}

void on_button_bs_find_clicked(GtkButton *button, gpointer user_data)
{
}

void on_button_bs_refresh_clicked(GtkButton *button, gpointer user_data)
{
  G_CONST_RETURN gchar *server = NULL;

  server = gtk_entry_get_text(GTK_ENTRY(ctlBS.combo_entry_server));
  gj_agent_list_request((gchar*)server, (agentCallback) gj_gtk_bs_agent_list_response);

  gj_gtk_bs_timer_start();
}

void on_button_bs_register_clicked(GtkButton *button, gpointer user_data)
{
  gchar *jid = NULL;

  gj_gtk_bs_set_jid(jid);

  if(gj_gtk_bs_model_get_selection(&jid) == TRUE && jid != NULL)
    {
      gj_gtk_rs_load(jid);
      gj_gtk_bs_unload();
    }
  
  /* clean up */
  if(jid != NULL) g_free(jid);
}

void on_button_bs_unregister_clicked(GtkButton *button, gpointer user_data)
{
  gchar *jid = NULL;

  gj_gtk_bs_set_jid(jid);

  if(gj_gtk_bs_model_get_selection(&jid) == TRUE)
    gj_iq_request_unregister(jid, gj_gtk_bs_unregister_response);
  
  /* clean up */
  if(jid != NULL) g_free(jid);
}

void on_browse_services_response(GtkDialog *dialog, gint response, gpointer user_data)
{
  switch(response) 
    {
    case GTK_RESPONSE_OK:
    case GTK_RESPONSE_HELP:
    case GTK_RESPONSE_NONE:
    case GTK_RESPONSE_REJECT:
    case GTK_RESPONSE_ACCEPT:
    case GTK_RESPONSE_DELETE_EVENT:
    case GTK_RESPONSE_CANCEL:
    case GTK_RESPONSE_CLOSE:
    case GTK_RESPONSE_YES:
    case GTK_RESPONSE_NO:
    case GTK_RESPONSE_APPLY:
      break;
    }

  gj_gtk_bs_unload();
}


#ifdef __cplusplus
}
#endif
