
/* 
 * $RCSfile: gj_gtk_my_preferences.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/31 16:43:54 $
 * 
 * $Revision: 1.16 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "common.h"

#include "gj_main.h"
#include "gj_roster.h"
#include "gj_config.h"
#include "gj_me.h"

#include "gj_gtk_roster.h"
#include "gj_gtk_my_preferences.h"
#include "gj_gtk_docklet.h"


struct 
{
  GtkWidget *window;

  GtkWidget *checkbutton_hide_offline_contacts;
  GtkWidget *checkbutton_hide_offline_group;
  GtkWidget *checkbutton_hide_agents;
  GtkWidget *checkbutton_hide_contact_presence_details;

  GtkWidget *radiobutton_double_click_for_chat;
  GtkWidget *radiobutton_double_click_for_message;

  GtkWidget *checkbutton_close_previous_message_window_on_reply;
  GtkWidget *checkbutton_raise_window_on_new_message;
  GtkWidget *checkbutton_hide_time;
  GtkWidget *checkbutton_reverse_text_direction;

  GtkWidget *checkbutton_use_spell_checker;

  GtkWidget *spinbutton_auto_away_after;
  GtkWidget *spinbutton_auto_xa_after;
  GtkWidget *textview_auto_away_status;
  GtkWidget *textview_auto_xa_status;

  GtkWidget *entry_browse_log_location;

  GtkWidget *file_selector;

  GtkWidget *button_browse_sound_on_user_online;
  GtkWidget *button_browse_sound_on_user_offline;
  GtkWidget *button_browse_sound_on_receive_message;
  GtkWidget *button_browse_sound_on_receive_chat;
  GtkWidget *button_browse_sound_on_receive_url;
  GtkWidget *button_browse_sound_on_receive_error;

  GtkWidget *table_sound;
/*  GtkWidget *checkbutton_sound_enabled;*/
  GtkWidget *checkbutton_sound_on_user_online;
  GtkWidget *checkbutton_sound_on_user_offline;
  GtkWidget *checkbutton_sound_on_receive_message;
  GtkWidget *checkbutton_sound_on_receive_chat;
  GtkWidget *checkbutton_sound_on_receive_url;
  GtkWidget *checkbutton_sound_on_receive_error;
/*  GtkWidget *checkbutton_sound_beep_if_no_file;*/
  GtkWidget *entry_sound_file_on_user_online;
  GtkWidget *entry_sound_file_on_user_offline;
  GtkWidget *entry_sound_file_on_receive_message;
  GtkWidget *entry_sound_file_on_receive_chat;
  GtkWidget *entry_sound_file_on_receive_url;
  GtkWidget *entry_sound_file_on_receive_error;
/*  GtkWidget *entry_sound_beep_if_no_file;*/

  GtkWidget *checkbutton_use_docklet;

  GtkWidget *button_browse_log_location;
  GtkWidget *button_browse_history_location;
  GtkWidget *checkbutton_use_history;
  GtkWidget *entry_browse_history_location;

  GtkWidget *notebook;
    
  GtkWidget *button_ok;
  GtkWidget *button_apply;
  GtkWidget *button_cancel;

} ctlMPF;

#define BROWSE_SOUND_ON_USER_ONLINE 1
#define BROWSE_SOUND_ON_USER_OFFLINE 2
#define BROWSE_SOUND_ON_RECEIVE_MESSAGE 3
#define BROWSE_SOUND_ON_RECEIVE_CHAT 4
#define BROWSE_SOUND_ON_RECEIVE_URL 5
#define BROWSE_SOUND_ON_RECEIVE_ERROR 6
#define BROWSE_LOG_LOCATION 7
#define BROWSE_HISTORY_LOCATION 8

gboolean gj_gtk_mpf_get();
gboolean gj_gtk_mpf_set();

void gj_gtk_mpf_store_filename(GtkFileSelection *file_selector, gpointer user_data);
void gj_gtk_mpf_create_file_selection(guint sound);

/*
 * GUI functions
 */
void on_checkbutton_mpf_sound_enabled_toggled(GtkToggleButton *togglebutton, gpointer user_data);
void on_checkbutton_mpf_hide_offline_contacts_toggled(GtkToggleButton *togglebutton, gpointer user_data);

void on_button_mpf_browse_sound_on_user_online_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_user_offline_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_message_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_chat_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_url_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_error_clicked(GtkButton *button, gpointer user_data);

void on_button_mpf_browse_log_location_clicked(GtkButton *button, gpointer user_data);

void on_checkbutton_mpf_use_history_toggled(GtkToggleButton *togglebutton, gpointer user_data);
void on_button_mpf_browse_history_location_clicked(GtkButton *button, gpointer user_data);

void on_my_preferences_response(GtkDialog *dialog, gint response, gpointer user_data);

/*
 * code
 */
gboolean gj_gtk_mpf_load()
{
  GladeXML *xml = NULL;

  GtkTextBuffer *buffer = NULL;
  GtkTextIter iter;

  GtkWidget *page = NULL;

  if(ctlMPF.window != NULL)
    {
      g_message("showing");
      gtk_window_present(GTK_WINDOW(ctlMPF.window));
      return TRUE;
    }

  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "my_preferences",
			  NULL)) == NULL)
    {
      g_warning("gj_gtk_mpf_load: couldn't open glade file at root 'my_preferences'");
      return FALSE;
    }
  
  ctlMPF.window = glade_xml_get_widget(xml,"my_preferences");

  ctlMPF.checkbutton_hide_offline_contacts = glade_xml_get_widget(xml,"checkbutton_mpf_hide_offline_contacts");
  ctlMPF.checkbutton_hide_offline_group = glade_xml_get_widget(xml,"checkbutton_mpf_hide_offline_group");
  ctlMPF.checkbutton_hide_agents = glade_xml_get_widget(xml,"checkbutton_mpf_hide_agents");
  ctlMPF.checkbutton_hide_contact_presence_details = glade_xml_get_widget(xml,"checkbutton_mpf_hide_contact_presence_details");

  ctlMPF.radiobutton_double_click_for_chat = glade_xml_get_widget(xml,"radiobutton_mpf_double_click_for_chat");
  ctlMPF.radiobutton_double_click_for_message = glade_xml_get_widget(xml,"radiobutton_mpf_double_click_for_message");

  ctlMPF.checkbutton_close_previous_message_window_on_reply = glade_xml_get_widget(xml,"checkbutton_mpf_close_previous_message_window_on_reply");
  ctlMPF.checkbutton_raise_window_on_new_message = glade_xml_get_widget(xml,"checkbutton_mpf_raise_window_on_new_message");
  ctlMPF.checkbutton_hide_time = glade_xml_get_widget(xml,"checkbutton_mpf_hide_time");
  ctlMPF.checkbutton_reverse_text_direction = glade_xml_get_widget(xml,"checkbutton_mpf_reverse_text_direction");

  ctlMPF.checkbutton_use_spell_checker = glade_xml_get_widget(xml,"checkbutton_mpf_use_spell_checker");

  ctlMPF.spinbutton_auto_away_after = glade_xml_get_widget(xml,"spinbutton_mpf_auto_away_after");
  ctlMPF.spinbutton_auto_xa_after = glade_xml_get_widget(xml,"spinbutton_mpf_auto_xa_after");
  ctlMPF.textview_auto_away_status = glade_xml_get_widget(xml,"textview_mpf_auto_away_status");
  ctlMPF.textview_auto_xa_status = glade_xml_get_widget(xml,"textview_mpf_auto_xa_status");

  ctlMPF.entry_browse_log_location = glade_xml_get_widget(xml,"entry_mpf_browse_log_location");

  ctlMPF.button_browse_sound_on_user_online = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_user_online");
  ctlMPF.button_browse_sound_on_user_offline = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_user_offline");
  ctlMPF.button_browse_sound_on_receive_message = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_message");
  ctlMPF.button_browse_sound_on_receive_chat = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_chat");
  ctlMPF.button_browse_sound_on_receive_url = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_url");
  ctlMPF.button_browse_sound_on_receive_error = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_error");

  ctlMPF.table_sound = glade_xml_get_widget(xml,"table_mpf_sound");
/*  ctlMPF.checkbutton_sound_enabled = glade_xml_get_widget(xml,"checkbutton_mpf_sound_enabled");*/
  ctlMPF.checkbutton_sound_on_user_online = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_user_online");
  ctlMPF.checkbutton_sound_on_user_offline = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_user_offline");
  ctlMPF.checkbutton_sound_on_receive_message = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_message");
  ctlMPF.checkbutton_sound_on_receive_chat = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_chat");
  ctlMPF.checkbutton_sound_on_receive_url = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_url");
  ctlMPF.checkbutton_sound_on_receive_error = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_error");
/*  ctlMPF.checkbutton_sound_beep_if_no_file = glade_xml_get_widget(xml,"checkbutton_mpf_sound_beep_if_no_file");*/
  ctlMPF.entry_sound_file_on_user_online = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_user_online");
  ctlMPF.entry_sound_file_on_user_offline = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_user_offline");
  ctlMPF.entry_sound_file_on_receive_message = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_message");
  ctlMPF.entry_sound_file_on_receive_chat = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_chat");
  ctlMPF.entry_sound_file_on_receive_url = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_url");
  ctlMPF.entry_sound_file_on_receive_error = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_error");

  ctlMPF.checkbutton_use_docklet = glade_xml_get_widget(xml,"checkbutton_mpf_use_docklet");

  ctlMPF.button_browse_log_location = glade_xml_get_widget(xml,"button_mpf_browse_log_location");
  ctlMPF.button_browse_history_location = glade_xml_get_widget(xml,"button_mpf_browse_history_location");
  ctlMPF.checkbutton_use_history = glade_xml_get_widget(xml,"checkbutton_mpf_use_history");
  ctlMPF.entry_browse_history_location = glade_xml_get_widget(xml,"entry_mpf_browse_history_location");

  ctlMPF.notebook = glade_xml_get_widget(xml, "notebook_mpf");

  ctlMPF.button_ok = glade_xml_get_widget(xml,"button_mpf_apply");
  ctlMPF.button_apply = glade_xml_get_widget(xml,"button_mpf_apply");
  ctlMPF.button_cancel = glade_xml_get_widget(xml,"button_mpf_cancel");
  
  gdk_window_set_decorations (GDK_WINDOW(ctlMPF.window->window), 
			      GDK_DECOR_BORDER | GDK_DECOR_TITLE | GDK_DECOR_MENU);

#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  g_signal_connect ((gpointer) ctlMPF.window, "response",
		    G_CALLBACK (on_my_preferences_response),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.checkbutton_hide_offline_contacts, "toggled",
		    G_CALLBACK (on_checkbutton_mpf_hide_offline_contacts_toggled),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_sound_on_user_online, "clicked",
		    G_CALLBACK (on_button_mpf_browse_sound_on_user_online_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_sound_on_user_offline, "clicked",
		    G_CALLBACK (on_button_mpf_browse_sound_on_user_offline_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_sound_on_receive_message, "clicked",
		    G_CALLBACK (on_button_mpf_browse_sound_on_receive_message_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_sound_on_receive_chat, "clicked",
		    G_CALLBACK (on_button_mpf_browse_sound_on_receive_chat_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_sound_on_receive_url, "clicked",
		    G_CALLBACK (on_button_mpf_browse_sound_on_receive_url_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_sound_on_receive_error, "clicked",
		    G_CALLBACK (on_button_mpf_browse_sound_on_receive_error_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_log_location, "clicked",
		    G_CALLBACK (on_button_mpf_browse_log_location_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.button_browse_history_location, "clicked",
		    G_CALLBACK (on_button_mpf_browse_history_location_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlMPF.checkbutton_use_history, "toggled",
		    G_CALLBACK (on_checkbutton_mpf_use_history_toggled),
		    NULL);
#endif

#ifdef WIN32
  /* if windows hide the notification tab */
  page = gtk_notebook_get_nth_page(GTK_NOTEBOOK(ctlMPF.notebook), 3);
  gtk_widget_hide(page);
#endif

  /* get settings */
  gj_gtk_mpf_get();

  /* set up settings */
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_contacts), gj_config_get_mpf_hide_offline_contacts());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_group), gj_config_get_mpf_hide_offline_group());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_agents), gj_config_get_mpf_hide_agents());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_contact_presence_details), gj_config_get_mpf_hide_contact_presence_details());

  if(gj_config_get_mpf_double_click_for_chat() == TRUE)
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.radiobutton_double_click_for_chat), TRUE);
  else
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.radiobutton_double_click_for_message), TRUE);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_close_previous_message_window_on_reply),
			       gj_config_get_mpf_close_previous_message_window_on_reply());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_raise_window_on_new_message),
			       gj_config_get_mpf_raise_window_on_new_message());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_time),
			       gj_config_get_mpf_hide_time());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_reverse_text_direction),
			       gj_config_get_mpf_reverse_text_direction());

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_spell_checker),
			       gj_config_get_mpf_use_spell_checker());

  gtk_spin_button_set_value(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_away_after), (gdouble)gj_config_get_mpf_auto_away_after());
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_xa_after), (gdouble)gj_config_get_mpf_auto_xa_after());
  
  if(gj_config_get_mpf_auto_away_status() != NULL && g_utf8_strlen(gj_config_get_mpf_auto_away_status(),-1) > 0)
    {
      buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_away_status));
      gtk_text_buffer_get_start_iter(buffer, &iter);
      gtk_text_buffer_insert(buffer, &iter, gj_config_get_mpf_auto_away_status(), -1);
    }

  if(gj_config_get_mpf_auto_xa_status() != NULL && g_utf8_strlen(gj_config_get_mpf_auto_xa_status(),-1) > 0)
    {
      buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_xa_status));
      gtk_text_buffer_get_start_iter(buffer, &iter);
      gtk_text_buffer_insert(buffer, &iter, gj_config_get_mpf_auto_xa_status(), -1);
    }

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_online), gj_config_get_mpf_sound_on_user_online());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_offline), gj_config_get_mpf_sound_on_user_offline());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_message), gj_config_get_mpf_sound_on_receive_message());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_chat), gj_config_get_mpf_sound_on_receive_chat());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_url), gj_config_get_mpf_sound_on_receive_url());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_error), gj_config_get_mpf_sound_on_receive_error());

  if(gj_config_get_mpf_sound_file_on_user_online() && g_utf8_strlen(gj_config_get_mpf_sound_file_on_user_online(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_online), gj_config_get_mpf_sound_file_on_user_online());
  if(gj_config_get_mpf_sound_file_on_user_offline() != NULL && g_utf8_strlen(gj_config_get_mpf_sound_file_on_user_offline(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_offline), gj_config_get_mpf_sound_file_on_user_offline());
  if(gj_config_get_mpf_sound_file_on_receive_message() != NULL && g_utf8_strlen(gj_config_get_mpf_sound_file_on_receive_message(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_message), gj_config_get_mpf_sound_file_on_receive_message());
  if(gj_config_get_mpf_sound_file_on_receive_chat() != NULL && g_utf8_strlen(gj_config_get_mpf_sound_file_on_receive_chat(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_chat), gj_config_get_mpf_sound_file_on_receive_chat());
  if(gj_config_get_mpf_sound_file_on_receive_url() != NULL && g_utf8_strlen(gj_config_get_mpf_sound_file_on_receive_url(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_url), gj_config_get_mpf_sound_file_on_receive_url());
  if(gj_config_get_mpf_sound_file_on_receive_error() != NULL && g_utf8_strlen(gj_config_get_mpf_sound_file_on_receive_error(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_error), gj_config_get_mpf_sound_file_on_receive_error());

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_docklet), gj_config_get_mpf_use_docklet());

  if(gj_config_get_mpf_log_location() != NULL && g_utf8_strlen(gj_config_get_mpf_log_location(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_log_location), gj_config_get_mpf_log_location());
  if(gj_config_get_mpf_history_location() != NULL && g_utf8_strlen(gj_config_get_mpf_history_location(), -1) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_history_location), gj_config_get_mpf_history_location());

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_history), gj_config_get_mpf_use_history());

  /* clean up */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_mpf_unload()
{
  gtk_widget_destroy(ctlMPF.window);
  ctlMPF.window = NULL;

  return TRUE;
}

gboolean gj_gtk_mpf_set()
{
  GtkTextBuffer *buffer = NULL;
  GtkTextIter bufStart;
  GtkTextIter bufStop;

  /* get values */
  gj_config_set_mpf_hide_offline_contacts(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_contacts)));
  gj_config_set_mpf_hide_offline_group(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_group)));
  gj_config_set_mpf_hide_agents(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_agents)));
  gj_config_set_mpf_hide_contact_presence_details(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_contact_presence_details)));

  gj_config_set_mpf_double_click_for_chat(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.radiobutton_double_click_for_chat)));

  gj_config_set_mpf_close_previous_message_window_on_reply(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_close_previous_message_window_on_reply)));
  gj_config_set_mpf_raise_window_on_new_message(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_raise_window_on_new_message)));
  gj_config_set_mpf_hide_time(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_time)));
  gj_config_set_mpf_reverse_text_direction(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_reverse_text_direction)));

  gj_config_set_mpf_use_spell_checker(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_spell_checker)));

  gj_config_set_mpf_auto_away_after(gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_away_after)));
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_away_status));
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStart, 0);
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStop, -1);
  gj_config_set_mpf_auto_away_status(gtk_text_buffer_get_text(buffer,&bufStart,&bufStop,TRUE));

  gj_config_set_mpf_auto_xa_after(gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_xa_after)));
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_xa_status));
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStart, 0);
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStop, -1);
  gj_config_set_mpf_auto_xa_status(gtk_text_buffer_get_text(buffer,&bufStart,&bufStop,TRUE));

  gj_config_set_mpf_sound_on_user_online(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_online)));
  gj_config_set_mpf_sound_on_user_offline(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_offline)));
  gj_config_set_mpf_sound_on_receive_message(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_message)));
  gj_config_set_mpf_sound_on_receive_chat(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_chat)));
  gj_config_set_mpf_sound_on_receive_url(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_url)));
  gj_config_set_mpf_sound_on_receive_error(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_error)));

  gj_config_set_mpf_sound_file_on_user_online((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_online)));
  gj_config_set_mpf_sound_file_on_user_offline((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_offline)));
  gj_config_set_mpf_sound_file_on_receive_message((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_message)));
  gj_config_set_mpf_sound_file_on_receive_chat((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_chat)));
  gj_config_set_mpf_sound_file_on_receive_url((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_url)));
  gj_config_set_mpf_sound_file_on_receive_error((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_error)));
  gj_config_set_mpf_use_docklet(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_docklet)));

  gj_config_set_mpf_log_location((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_browse_log_location)));
  gj_config_set_mpf_history_location((gchar*)gtk_entry_get_text(GTK_ENTRY(ctlMPF.entry_browse_history_location)));
  gj_config_set_mpf_use_history(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_history)));

  if(gj_config_write() == FALSE)
    return FALSE;

  if(gj_me_get_is_connected() == TRUE)
    {
      /* set program up */
      gj_gtk_roster_model_unload();
      gj_gtk_roster_model_load(gj_roster_get_list());
    }

  if(gj_config_get_mpf_use_docklet() == TRUE)
    gj_gtk_docklet_load();
  else
    gj_gtk_docklet_unload();

  return TRUE;
}

gboolean gj_gtk_mpf_get()
{
  if(gj_config_read() == FALSE)
    g_message("gj_gtk_mpf_get: config read failed, continuing anyway...");

  return TRUE;
}

void gj_gtk_mpf_store_filename(GtkFileSelection *file_selector, gpointer user_data) 
{
   const gchar *selected_filename;
   guint browse = 0;
 
   browse = GPOINTER_TO_INT(user_data);
   selected_filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(ctlMPF.file_selector));

   if(selected_filename == NULL || g_utf8_strlen(selected_filename, -1) < 1)
     {
       g_warning("gj_gtk_mpf_store_filename: not saving filename for browse id:%d, filename was NULL or length was < 1", browse);
       return;
     }

   g_message("gj_gtk_mpf_store_filename: selected filename: %s for browse:%d", selected_filename, browse);

   switch(browse)
     {
     case BROWSE_SOUND_ON_USER_ONLINE:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_online), selected_filename);
       break;
     case BROWSE_SOUND_ON_USER_OFFLINE:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_offline), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_MESSAGE:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_message), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_CHAT:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_chat), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_URL:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_url), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_ERROR:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_error), selected_filename);
       break;
     case BROWSE_LOG_LOCATION:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_log_location), selected_filename);
       break;
     case BROWSE_HISTORY_LOCATION:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_history_location), selected_filename);
       break;


     default:
       g_warning("gj_gtk_mpf_store_filename: default reached when checking browse id");
       break;
     }

   ctlMPF.file_selector = NULL;
}

void gj_gtk_mpf_create_file_selection(guint sound) 
{
   /* Create the selector */
   ctlMPF.file_selector = gtk_file_selection_new(_("Select File for Sound"));
   
   g_signal_connect((gpointer) GTK_FILE_SELECTION(ctlMPF.file_selector)->ok_button,
		    "clicked",
		    G_CALLBACK(gj_gtk_mpf_store_filename),
		    GINT_TO_POINTER(sound));
   			   
   /* Ensure that the dialog box is destroyed when the user clicks a button. */
   g_signal_connect_swapped((gpointer) GTK_FILE_SELECTION(ctlMPF.file_selector)->ok_button,
			    "clicked",
			    G_CALLBACK(gtk_widget_destroy), 
			    (gpointer)ctlMPF.file_selector); 
   
   g_signal_connect_swapped((gpointer) GTK_FILE_SELECTION(ctlMPF.file_selector)->cancel_button,
			    "clicked",
			    G_CALLBACK(gtk_widget_destroy),
			    (gpointer)ctlMPF.file_selector); 
   
   /* Display that dialog */
   gtk_widget_show(ctlMPF.file_selector);
}

/*
 * GUI events
 */
void on_button_mpf_browse_sound_on_user_online_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_USER_ONLINE);
}

void on_button_mpf_browse_sound_on_user_offline_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_USER_OFFLINE);
}

void on_button_mpf_browse_sound_on_receive_message_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_MESSAGE);
}

void on_button_mpf_browse_sound_on_receive_chat_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_CHAT);
}

void on_button_mpf_browse_sound_on_receive_url_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_URL);
}

void on_button_mpf_browse_sound_on_receive_error_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_ERROR);
}

void on_button_mpf_browse_log_location_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_LOG_LOCATION);
}

void on_button_mpf_browse_history_location_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_HISTORY_LOCATION);
}

void on_checkbutton_mpf_use_history_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
  gboolean active = FALSE;
  active = gtk_toggle_button_get_active(togglebutton);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.entry_browse_history_location), active);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.button_browse_history_location), active);
}

void on_checkbutton_mpf_sound_enabled_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
  gboolean active = FALSE;
  active = gtk_toggle_button_get_active(togglebutton);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.table_sound), active);
}

void on_checkbutton_mpf_hide_offline_contacts_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.checkbutton_hide_offline_group), 
			   !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)));
}

void on_my_preferences_response(GtkDialog *dialog, gint response, gpointer user_data)
{
  switch(response) 
    {
    case GTK_RESPONSE_OK:
      gj_gtk_mpf_set();
      break;

    case GTK_RESPONSE_APPLY:
      gj_gtk_mpf_set();
      return;

    case GTK_RESPONSE_ACCEPT:
    case GTK_RESPONSE_HELP:
    case GTK_RESPONSE_NONE:
    case GTK_RESPONSE_REJECT:
    case GTK_RESPONSE_DELETE_EVENT:
    case GTK_RESPONSE_CANCEL:
    case GTK_RESPONSE_CLOSE:
    case GTK_RESPONSE_YES:
    case GTK_RESPONSE_NO:
      break;
    }

  gj_gtk_mpf_unload();
}


#ifdef __cplusplus
}
#endif
