/* 
 * $RCSfile: gj_gtk_subscription_request.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/08/23 11:17:26 $
 * 
 * $Revision: 1.10 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "common.h"

#include "gj_main.h"
#include "gj_iq.h"
#include "gj_parser.h"
#include "gj_presence.h"
#include "gj_roster.h"

#include "gj_gtk_subscription_request.h"
#include "gj_gtk_add_contact.h"
#include "gj_gtk_user_information.h"
#include "gj_gtk_roster.h"
#include "gj_gtk_message.h"


/* columns */
enum
  { 
    COL_SUBSCRIPTION_REQUEST_JID,
    COL_SUBSCRIPTION_REQUEST_NICKNAME,
    COL_SUBSCRIPTION_REQUEST_REASON,
    COL_SUBSCRIPTION_REQUEST_ALLOW,
    COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER,
    COL_SUBSCRIPTION_REQUEST_COUNT
  };


struct
{
  GtkWidget *window;

  GtkWidget *treeview;

  GtkWidget *button_view_information;
  GtkWidget *button_send_message;

  GtkWidget *button_deny_all;
  GtkWidget *button_allow_all;

  GtkWidget *button_add_all_to_roster;
  GtkWidget *button_remove_all_from_roster;

  GtkWidget *button_add;

} ctlSR;


/* 
 * window functions 
 */
gboolean gj_gtk_sr_send_allow();
gboolean gj_gtk_sr_send_deny();

gboolean gj_gtk_sr_allow_all();
gboolean gj_gtk_sr_deny_all();

gboolean gj_gtk_sr_add_all_to_roster();
gboolean gj_gtk_sr_remove_all_from_roster();

/*
 * model functions 
 */
gboolean gj_gtk_sr_model_setup();

gboolean gj_gtk_sr_model_populate_columns(GtkTreeView *treeview);
gboolean gj_gtk_sr_model_populate();

gboolean gj_gtk_sr_model_add(presence pres);
gboolean gj_gtk_sr_model_get_selection(gchar **jid, gboolean *allow, gboolean *add_to_roster);

/*
 * gui callbacks
 */
void on_treeview_sr_allow_cell_toggled(GtkCellRendererToggle *cell, gchar *path_string, gpointer data);
void on_treeview_sr_add_to_roster_cell_toggled(GtkCellRendererToggle *cell, gchar *path_string, gpointer data);

void on_treeview_sr_selection_changed(GtkTreeSelection *treeselection, gpointer user_data);

void on_button_sr_view_information_clicked(GtkButton *button, gpointer user_data);
void on_button_sr_send_message_clicked(GtkButton *button, gpointer user_data);

void on_button_sr_deny_all_clicked(GtkButton *button, gpointer user_data);
void on_button_sr_allow_all_clicked(GtkButton *button, gpointer user_data);

void on_button_sr_add_all_to_roster_clicked(GtkButton *button, gpointer user_data);
void on_button_sr_remove_all_from_roster_clicked(GtkButton *button, gpointer user_data);

void on_button_sr_add_clicked(GtkButton *button, gpointer user_data);

void on_subscription_request_response(GtkDialog *dialog, gint response, gpointer user_data);


/*
 * window functions
 */
gboolean gj_gtk_sr_load(presence pres)
{
  GladeXML *xml = NULL;
  
  if(pres == NULL)
    {
      g_warning("gj_gtk_sr_load: presence was NULL");
      return FALSE;
    }

  if(ctlSR.window != NULL)
    {
      gtk_window_present(GTK_WINDOW(ctlSR.window));

      /* need to add to list here... */
      gj_gtk_sr_model_add(pres);

      return TRUE;
    }

  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "subscription_request",
			  NULL)) == NULL)
    {
      g_warning("gj_gtk_sr_load: couldn't open glade file at root 'subscription_request'");
      return FALSE;
    }
  
  ctlSR.window = glade_xml_get_widget(xml,"subscription_request");

  ctlSR.treeview = glade_xml_get_widget(xml,"treeview_sr");

  ctlSR.button_view_information = glade_xml_get_widget(xml,"button_sr_view_information");
  ctlSR.button_send_message = glade_xml_get_widget(xml,"button_sr_send_message");

  ctlSR.button_deny_all = glade_xml_get_widget(xml,"button_sr_deny_all");
  ctlSR.button_allow_all = glade_xml_get_widget(xml,"button_sr_allow_all");

  ctlSR.button_add_all_to_roster = glade_xml_get_widget(xml,"button_sr_add_all_to_roster");
  ctlSR.button_remove_all_from_roster = glade_xml_get_widget(xml,"button_sr_remove_all_from_roster");

  ctlSR.button_add = glade_xml_get_widget(xml,"button_sr_add");
  
  gdk_window_set_decorations (GDK_WINDOW(ctlSR.window->window), 
			      GDK_DECOR_BORDER | GDK_DECOR_TITLE | GDK_DECOR_MENU);

#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  g_signal_connect ((gpointer) ctlSR.window, "response",
		    G_CALLBACK (on_subscription_request_response),
		    NULL);
  g_signal_connect ((gpointer) ctlSR.button_view_information, "clicked",
		    G_CALLBACK (on_button_sr_view_information_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlSR.button_send_message, "clicked",
		    G_CALLBACK (on_button_sr_send_message_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlSR.button_deny_all, "clicked",
		    G_CALLBACK (on_button_sr_deny_all_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlSR.button_allow_all, "clicked",
		    G_CALLBACK (on_button_sr_allow_all_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlSR.button_add_all_to_roster, "clicked",
		    G_CALLBACK (on_button_sr_add_all_to_roster_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlSR.button_remove_all_from_roster, "clicked",
		    G_CALLBACK (on_button_sr_remove_all_from_roster_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlSR.button_add, "clicked",
                    G_CALLBACK (on_button_sr_add_clicked),
                    NULL);
#endif

  /* set up model */
  gj_gtk_sr_model_setup();

  /* need to add to list here... */
  gj_gtk_sr_model_add(pres);

  /* clean up */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_sr_unload()
{
  if(ctlSR.window == NULL)
    return TRUE;

  gtk_widget_destroy(ctlSR.window);

  ctlSR.window = NULL;

  ctlSR.treeview = NULL;

  ctlSR.button_view_information = NULL;
  ctlSR.button_send_message = NULL;

  ctlSR.button_deny_all = NULL;
  ctlSR.button_allow_all = NULL;

  ctlSR.button_add_all_to_roster = NULL;
  ctlSR.button_remove_all_from_roster = NULL;

  return TRUE;
}

/*
 * model functions 
 */
gboolean gj_gtk_sr_model_setup()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreeSelection *selection = NULL;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_model_setup: view is NULL");
      return FALSE;
    }

  if((selection = GTK_TREE_SELECTION(gtk_tree_view_get_selection(view))) == NULL)
    {
      g_warning("gj_gtk_sr_model_setup: selection was NULL");
      return FALSE;
    }

  /* create tree store */
  store = gtk_list_store_new(COL_SUBSCRIPTION_REQUEST_COUNT,
			     G_TYPE_STRING,   /* jid */
			     G_TYPE_STRING,   /* name */
			     G_TYPE_STRING,   /* reason */
			     G_TYPE_BOOLEAN,  /* allow */
			     G_TYPE_BOOLEAN); /* add to roster */
  
  /* model */
  model = GTK_TREE_MODEL(store);
  gtk_tree_view_set_model(view, model);

  /* selection */
  gtk_tree_selection_set_mode(selection, GTK_SELECTION_SINGLE);
  g_signal_connect(G_OBJECT(selection), "changed", G_CALLBACK(on_treeview_sr_selection_changed), NULL);

  /* populate columns */
  gj_gtk_sr_model_populate_columns(view);

  /* properties */
  gtk_tree_view_set_enable_search(view,FALSE);
  gtk_tree_view_set_search_column(view,COL_SUBSCRIPTION_REQUEST_JID); 
  gtk_tree_view_set_rules_hint(view, FALSE);
  gtk_tree_view_set_headers_visible(view,TRUE);
  gtk_tree_view_set_headers_clickable(view,TRUE);
  gtk_tree_view_columns_autosize(view);
  gtk_tree_view_expand_all(view);

  /* clean up */
  g_object_unref(G_OBJECT(model));

  return TRUE;
}

gboolean gj_gtk_sr_model_populate_columns(GtkTreeView *view)
{
  GtkTreeModel *model = NULL;
  GtkTreeViewColumn *column = NULL; 
  GtkCellRenderer *renderer = NULL;

  guint col_offset = 0;

  if(GTK_TREE_VIEW(view) == NULL)
    {
      g_warning("gj_gtk_sr_model_populate_columns: view was NULL");
      return FALSE;
    }
  
  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_model_populate_columns: model was NULL");
      return FALSE;
    }

  /* COL_SUBSCRIPTION_REQUEST_ALLOW */
  renderer = gtk_cell_renderer_toggle_new();
  g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(on_treeview_sr_allow_cell_toggled), NULL);

  column = gtk_tree_view_column_new_with_attributes(_("Allow"),
						    renderer,
						    "active", COL_SUBSCRIPTION_REQUEST_ALLOW,
						    NULL);

  /* set this column to a fixed sizing (of 50 pixels) */
  gtk_tree_view_column_set_sizing(GTK_TREE_VIEW_COLUMN(column), GTK_TREE_VIEW_COLUMN_FIXED); 
  gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 40); 
  gtk_tree_view_column_set_alignment(GTK_TREE_VIEW_COLUMN(column), 0.5);
  gtk_tree_view_append_column(view, column);

#if 0
  /* COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER */
  renderer = gtk_cell_renderer_toggle_new();
  g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(on_treeview_sr_add_to_roster_cell_toggled), NULL);

  column = gtk_tree_view_column_new_with_attributes(_("Add"),
						    renderer,
						    "active", COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER,
						    NULL);

  /* set this column to a fixed sizing (of 50 pixels) */
  gtk_tree_view_column_set_sizing(GTK_TREE_VIEW_COLUMN(column), GTK_TREE_VIEW_COLUMN_FIXED); 
  gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 40); 
  gtk_tree_view_column_set_alignment(GTK_TREE_VIEW_COLUMN(column), 0.5);
  gtk_tree_view_append_column(view, column);
#endif

  /* COL_SUBSCRIPTION_REQUEST_JID */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, "Jabber ID",
							   renderer, 
							   "text", COL_SUBSCRIPTION_REQUEST_JID,
							   NULL);
  
  /* set extra information */
  g_object_set_data(G_OBJECT(renderer), "column", (gint *)COL_SUBSCRIPTION_REQUEST_JID);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_SUBSCRIPTION_REQUEST_JID);
  gtk_tree_view_column_set_resizable(column,TRUE);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);

#if 0
  /* COL_SUBSCRIPTION_REQUEST_NAME */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Nickname"),
							   renderer, 
							   "text", COL_SUBSCRIPTION_REQUEST_NICKNAME,
							   NULL);
  
  /* set extra information */
  g_object_set_data(G_OBJECT(renderer), "column", (gint *)COL_SUBSCRIPTION_REQUEST_NICKNAME);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_SUBSCRIPTION_REQUEST_NICKNAME);
  gtk_tree_view_column_set_resizable(column,TRUE);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
#endif

  /* COL_SUBSCRIPTION_REQUEST_REASON */
  renderer = gtk_cell_renderer_text_new();
  col_offset = gtk_tree_view_insert_column_with_attributes(view,
							   -1, _("Reason"),
							   renderer, 
							   "text", COL_SUBSCRIPTION_REQUEST_REASON,
							   NULL);
  
  /* set extra information */
  g_object_set_data(G_OBJECT(renderer), "column", (gint *)COL_SUBSCRIPTION_REQUEST_REASON);

  column = gtk_tree_view_get_column(view, col_offset - 1);
  gtk_tree_view_column_set_sort_column_id(column, COL_SUBSCRIPTION_REQUEST_REASON);
  gtk_tree_view_column_set_resizable(column,TRUE);
  gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);

  return TRUE;
}

gboolean gj_gtk_sr_model_add(presence pres)
{
  GtkTreeView *view = NULL;
  GtkListStore *store = NULL;
  GtkTreeIter iter;

  gchar *name = NULL;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_model_add: view is NULL");
      return FALSE;
    }

  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_model_add: store was NULL");
      return FALSE;
    }

  if(gj_presence_get_from_jid(pres) == NULL)
    {
      g_warning("gj_gtk_sr_model_add: jid was NULL");
      return FALSE;
    }

  g_message("gj_gtk_sr_model_add: adding jid:'%s', name:'%s', reason:'%s'", 
	    gj_presence_get_from_jid(pres), name, gj_presence_get_status(pres));  

  /* add */
  gtk_list_store_append(store, &iter);
  gtk_list_store_set(store, &iter,    
		     COL_SUBSCRIPTION_REQUEST_JID, gj_presence_get_from_jid(pres),
		     COL_SUBSCRIPTION_REQUEST_NICKNAME, name,
		     COL_SUBSCRIPTION_REQUEST_REASON, gj_presence_get_status(pres),
		     COL_SUBSCRIPTION_REQUEST_ALLOW, FALSE,
		     COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, FALSE,
		     -1);
    
  return TRUE;
}

gboolean gj_gtk_sr_model_get_selection(gchar **jid, gboolean *allow, gboolean *add_to_roster)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeSelection *selection = NULL;
  GtkTreeIter iter;

  gboolean is_selection = FALSE;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_model_get_selection: view was NULL");
      return FALSE;
    }
  
  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_model_get_selection: model was NULL");
      return FALSE;
    }

  if((selection = GTK_TREE_SELECTION(gtk_tree_view_get_selection(view))) == NULL)
    {
      g_warning("gj_gtk_sr_model_get_selection: selection was NULL");
      return FALSE;
    }
  
  if(jid == NULL || allow == NULL || add_to_roster == NULL)
    {
      g_warning("gj_gtk_sr_model_get_selection: jid, allow, or add_to_roster pointers passed were NULL");
      return FALSE;
    }

  is_selection = gtk_tree_selection_get_selected(selection,&model,&iter);
  if(is_selection == FALSE)
    return FALSE;

  gtk_tree_model_get(model, &iter, 
		     COL_SUBSCRIPTION_REQUEST_JID, jid,
		     COL_SUBSCRIPTION_REQUEST_ALLOW, allow,
		     COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, add_to_roster,
		     -1);     

  return TRUE;
}

gboolean gj_gtk_sr_allow_all()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreeIter iter;
  
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_allow_all: view was NULL");
      return FALSE;
    }
  
  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_allow_all: model was NULL");
      return FALSE;
    }

  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_add_all_to_roster: model was NULL");
      return FALSE;
    }

  /* Get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(; valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      gtk_list_store_set(store, &iter,    
			 COL_SUBSCRIPTION_REQUEST_ALLOW, TRUE,
			 -1);
    }
  
  return TRUE;
}

gboolean gj_gtk_sr_deny_all()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreeIter iter;
  
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_deny_all: view was NULL");
      return FALSE;
    }
  
  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_deny_all: model was NULL");
      return FALSE;
    }

  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_add_all_to_roster: model was NULL");
      return FALSE;
    }

  /* Get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(; valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      gtk_list_store_set(store, &iter,    
			 COL_SUBSCRIPTION_REQUEST_ALLOW, FALSE,
			 -1);
    }
  
  return TRUE;
}

gboolean gj_gtk_sr_add_all_to_roster()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreeIter iter;
  
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_add_all_to_roster: view was NULL");
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_add_all_to_roster: model was NULL");
      return FALSE;
    }
  
  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_add_all_to_roster: model was NULL");
      return FALSE;
    }

  /* Get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(; valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      gtk_list_store_set(store, &iter,    
			 COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, TRUE,
			 -1);
    }
  
  return TRUE;
}

gboolean gj_gtk_sr_remove_all_from_roster()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreeIter iter;
  
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_remove_all_from_roster: view was NULL");
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_remove_all_from_roster: model was NULL");
      return FALSE;
    }
  
  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_remove_all_from_roster: model was NULL");
      return FALSE;
    }

  /* Get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(; valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      gtk_list_store_set(store, &iter,    
			 COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, FALSE,
			 -1);
    }
  
  return TRUE;
}

gboolean gj_gtk_sr_send_allow(gchar *jid)
{
  if(jid == NULL)
    {
      g_warning("gj_gtk_sr_send_allow: jid was NULL");
      return FALSE;
    }

  g_message("gj_gtk_sr_send_allow: allowing subscription for jid:'%s'", jid);
  gj_presence_send_to(jid, presenceTypeSubscribed, presenceShowEnd, NULL, 0);

  /* NOTE: at this point, we want to use the contact_add dialog, and 
           start at the second stage where the name and groups are 
	   specified... */

  return TRUE;
}

gboolean gj_gtk_sr_send_deny(gchar *jid)
{
  rosterItem ri = NULL;

  if(jid == NULL)
    {
      g_warning("gj_gtk_sr_send_deny: jid was NULL");
      return FALSE;
    }

  if((ri = gj_roster_item_find_by_jid(jid)) == NULL)
    {
      g_warning("gj_gtk_sr_send_deny: could not find rosterItem by jid'%s'", jid);
      return FALSE;
    }

  g_message("gj_gtk_sr_send_deny: denying subscription for jid:'%s'", jid);
  gj_presence_send_to(jid, presenceTypeUnSubscribed, presenceShowEnd, NULL, 0);

  /* remove from roster */
  gj_gtk_roster_model_remove_contact(ri);

  return TRUE;
}

gboolean gj_gtk_sr_ok()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;
  
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_remove_all_from_roster: view was NULL");
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_remove_all_from_roster: model was NULL");
      return FALSE;
    }
  
  /* Get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(; valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      gchar *jid = NULL;
      gboolean allow = FALSE;
      gboolean add_to_roster = FALSE;

      gtk_tree_model_get(model, &iter,   
			 COL_SUBSCRIPTION_REQUEST_JID, &jid,
			 COL_SUBSCRIPTION_REQUEST_ALLOW, &allow,
			 COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, &add_to_roster,
			 -1);

      if(jid == NULL) continue;

      if(allow == TRUE)
	gj_gtk_sr_send_allow(jid);
      else
	gj_gtk_sr_send_deny(jid);

      if(add_to_roster == TRUE)
	gj_gtk_ac_load(jid); 

      /* clean up */
      g_free(jid);
    }
  
  return TRUE;
}

/*
 * GUI events
 */
void on_treeview_sr_allow_cell_toggled(GtkCellRendererToggle *cell, gchar *path_string, gpointer data)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreePath *path = NULL;
  GtkTreeIter iter;

  gboolean enabled = FALSE;
/*   gboolean add_to_roster = FALSE; */

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_allow_cell_toggled: view was NULL");
      return;
    }
  
  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_allow_cell_toggled: model was NULL");
      return;
    }

  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_allow_cell_toggled: store was NULL");
      return;
    }

  path = gtk_tree_path_new_from_string(path_string);

  /* get toggled iter */
  gtk_tree_model_get_iter(model, &iter, path);
  gtk_tree_model_get(model, &iter, 
		     COL_SUBSCRIPTION_REQUEST_ALLOW, &enabled, 
/* 		     COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, &add_to_roster,  */
		     -1);

  /* do something */
  enabled ^= 1;

  /* set new value */
  gtk_list_store_set(store, &iter, 
		     COL_SUBSCRIPTION_REQUEST_ALLOW, enabled, 
/* 		     COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, enabled ? add_to_roster : FALSE, */
		     -1);

  /* clean up */
  gtk_tree_path_free(path);

/*   g_message("on_treeview_sr_allow_cell_toggled: item is now %s", enabled?"enabled":"disabled"); */
}

void on_treeview_sr_add_to_roster_cell_toggled(GtkCellRendererToggle *cell, gchar *path_string, gpointer data)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkListStore *store = NULL;
  GtkTreePath *path = NULL;
  GtkTreeIter iter;

  gboolean enabled = FALSE;

  if((view = GTK_TREE_VIEW(ctlSR.treeview)) == NULL)
    {
      g_warning("gj_gtk_sr_add_to_roster_cell_toggled: view was NULL");
      return;
    }
  
  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_add_to_roster_cell_toggled: model was NULL");
      return;
    }

  if((store = GTK_LIST_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_sr_add_to_roster_cell_toggled: store was NULL");
      return;
    }

  path = gtk_tree_path_new_from_string(path_string);

  /* get toggled iter */
  gtk_tree_model_get_iter(model, &iter, path);
  gtk_tree_model_get(model, &iter, 
		     COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, &enabled, 
		     -1);

  /* do something */
  enabled ^= 1;

  /* disable all others first */
  gj_gtk_sr_remove_all_from_roster();

  /* set new value */
  gtk_list_store_set(store, &iter, 
		     COL_SUBSCRIPTION_REQUEST_ADD_TO_ROSTER, enabled, 
		     -1);

  /* clean up */
  gtk_tree_path_free(path);

/*   g_message("on_treeview_sr_add_to_roster_cell_toggled: item is now %s", enabled?"enabled":"disabled"); */
}

void on_treeview_sr_selection_changed(GtkTreeSelection *treeselection, gpointer user_data)
{
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;

  if(gtk_tree_selection_get_selected(treeselection, &model, &iter) == FALSE)
    {
      gtk_widget_set_sensitive(GTK_WIDGET(ctlSR.button_view_information), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(ctlSR.button_send_message), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(ctlSR.button_add), FALSE);
    }
  else
    {
      gchar *jid = NULL;

      gtk_widget_set_sensitive(GTK_WIDGET(ctlSR.button_view_information), TRUE);
      gtk_widget_set_sensitive(GTK_WIDGET(ctlSR.button_send_message), TRUE);
      gtk_widget_set_sensitive(GTK_WIDGET(ctlSR.button_add), TRUE);

      gtk_tree_model_get(model, &iter,
			 COL_SUBSCRIPTION_REQUEST_JID, &jid,
			 -1);

      if(jid != NULL)
	{
	  rosterItem ri = NULL;
	  ri = gj_roster_item_find_by_jid(jid);

	  if(ri != NULL && gj_roster_item_get_is_permanent(ri) == FALSE)
	    gtk_widget_show(GTK_WIDGET(ctlSR.button_add));
	  else
	    gtk_widget_hide(GTK_WIDGET(ctlSR.button_add));

	  g_free(jid);
	}
    }
}

void on_button_sr_view_information_clicked(GtkButton *button, gpointer user_data)
{
  gchar *jid = NULL;
  gboolean allow = FALSE;
  gboolean add_to_roster = FALSE;

  if(gj_gtk_sr_model_get_selection(&jid, &allow, &add_to_roster) == FALSE)
    return;

  /* load user information dialog */
  gj_gtk_ui_load(jid);

  if(jid != NULL) g_free(jid);
}

void on_button_sr_send_message_clicked(GtkButton *button, gpointer user_data)
{
  gchar *jid = NULL;
  gboolean allow = FALSE;
  gboolean add_to_roster = FALSE;

  if(gj_gtk_sr_model_get_selection(&jid, &allow, &add_to_roster) == FALSE)
    return;

  /* send message */
  gj_gtk_mw_send_new_by_jid(jid);

  if(jid != NULL) g_free(jid);
}

void on_button_sr_allow_all_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_sr_allow_all();
}

void on_button_sr_deny_all_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_sr_deny_all();
}

void on_button_sr_add_all_to_roster_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_sr_add_all_to_roster();
}

void on_button_sr_remove_all_from_roster_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_sr_remove_all_from_roster();
}

void on_button_sr_add_clicked(GtkButton *button, gpointer user_data)
{
  gchar *jid = NULL;
  gboolean allow = FALSE;
  gboolean add_to_roster = FALSE;

  if(gj_gtk_sr_model_get_selection(&jid, &allow, &add_to_roster) == FALSE)
    return;

  gj_gtk_ac_load(jid); 
}


void on_subscription_request_response(GtkDialog *dialog, gint response, gpointer user_data)
{
  switch(response) 
    {
    case GTK_RESPONSE_OK:
      gj_gtk_sr_ok();
      break;

    case GTK_RESPONSE_HELP:
    case GTK_RESPONSE_NONE:
    case GTK_RESPONSE_REJECT:
    case GTK_RESPONSE_ACCEPT:
    case GTK_RESPONSE_DELETE_EVENT:
    case GTK_RESPONSE_CANCEL:
    case GTK_RESPONSE_CLOSE:
    case GTK_RESPONSE_YES:
    case GTK_RESPONSE_NO:
    case GTK_RESPONSE_APPLY:
      break;
    }

  gj_gtk_sr_unload();
}

#ifdef __cplusplus
}
#endif
