/*
 * $RCSfile: gj_support.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/19 15:58:17 $
 *
 * $Revision: 1.6 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_support_h
#define __gj_support_h

#include <time.h>

typedef enum t_uriType {
  uriTypeUnknown = 1,
  uriTypeURL,
  uriTypeHost,

  uriTypeEnd
} uriType;

int gj_support_get_unique_id();

const char *gj_support_get_time_zone();

const char *gj_support_get_timestamp();
const char *gj_support_get_timestamp_long();
const char *gj_support_get_timestamp_from_timet(time_t now);

const char *gj_support_get_datestamp();
const char *gj_support_get_datestamp_long();
const char *gj_support_get_datestamp_from_timet(time_t now);

const char *gj_support_get_time_and_date_from_timet(time_t now);

const char *gj_support_get_timestamp_full();
const char *gj_support_get_timestamp_nice();
const char *gj_support_get_timestamp_nice_from_timet(time_t now);

gboolean gj_support_find_in_str(const gchar *needle, const gchar *haystack);
gchar *gj_support_find_in_str_and_remove(const gchar *needle, const gchar *haystack);
gchar *gj_support_find_in_str_and_replace(const gchar *needle, const gchar *haystack, const gchar *replacement);

gboolean gj_support_is_word_separator(gchar c);
uriType gj_support_is_uri(gchar *word);

char *gj_support_get_sha_by_session_id_and_password(gchar *session_id, gchar *password);


#endif

#ifdef __cplusplus
}
#endif
